/*
 * Copyright notice from original mutt:
 * Copyright (C) 1999-2000 Thomas Roessler <roessler@does-not-exist.org>
 *
 * This file is part of mutt-ng, see http://www.muttng.org/.
 * It's licensed under the GNU General Public License,
 * please see the file GPL in the top level source directory.
 */

#ifndef _CHARSET_H
#define _CHARSET_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "mutt.h"

#ifdef HAVE_ICONV_H
#include <iconv.h>
#endif

#ifndef HAVE_ICONV_T_DEF
typedef void *iconv_t;
#endif

#ifndef HAVE_ICONV
#  define iconv_open(a, b)     ((iconv_t)(-1))
#  define my_iconv(a,b,c,d,e)  0
#  define iconv_close(a)       0
#else
static inline ssize_t my_iconv(iconv_t ict, const char **inbuf, ssize_t *ilen,
                               char **outbuf, ssize_t *olen)
{
    return iconv(ict, (char **)inbuf, (size_t*)ilen, outbuf, (size_t*)olen);
}
#endif

int mutt_convert_string (char **, const char *, const char *, int);
const char *mutt_get_first_charset (const char *);
int mutt_convert_nonmime_string (char **);

iconv_t mutt_iconv_open (const char *, const char *, int);
size_t mutt_iconv (iconv_t, const char **, size_t *, char **, size_t *,
                   const char **, const char *);

typedef void *FGETCONV;

FGETCONV *fgetconv_open (FILE *, const char *, const char *, int);
int fgetconv (FGETCONV *);
char *fgetconvs (char *, size_t, FGETCONV *);
void fgetconv_close (FGETCONV **);

void mutt_set_langinfo_charset (void);

#define M_ICONV_HOOK_FROM 1
#define M_ICONV_HOOK_TO   2

#endif /* _CHARSET_H */
